<?php

function network_create_script($config, $id, $os, $action)
{
    $script = "";
    if ($info = apcu_fetch("apps." . $id)) {
        if ($os == 'linux') {
            $script_wifi_wpa = "";
            $script_802_1x_wired = "";
            $script_802_1x_wifi = "";

            if (! empty($config['wpa_ssid']) && ! empty($config['wpa_password'])) {
                // on configure le wifi en wpa2-psk
                $script_wifi_wpa .= "        if [ \"\$ssid\" == \"" . $config['wpa_ssid'] . "\" ]; then
            echo \"configuration wifi : \$interface pour le wpa2-psk\"
            nmcli c modify \$interface 802-11-wireless-security.key-mgmt wpa-psk \
802-11-wireless-security.psk " . $config['wpa_password'] . " || true
        fi
";
            }

            if (! empty($config['802_1x_wired']) || ! empty($config['802_1x_ssid'])) {
                $machine_key = exec("ssh -i /etc/sambaedu/id_rsa -o StrictHostKeyChecking=no root@" . $config['se4ad_name'] . "." . $config['domain'] . " pdbedit -Lw " . $info['machine']['samaccountname'] . " | cut -d \":\" -f4");
            }

            if (! empty($config['802_1x_wired'])) {
                // on configure le filaire en 802.1x
                $script_802_1x_wired .= "        echo \"configuration ethernet : \$interface pour le 802.1x\"
        nmcli c modify \$interface 802-1x.eap peap 802-1x.identity host/" . strtoupper($info['machine']['samaccountname']) . " \
802-1x.phase2-auth mschapv2 802-1x.password " . $machine_key . " 802-1x.optional true \
802-1x.phase1-peaplabel 1 802-1x.auth-timeout 3 802-1x.system-ca-certs true || true
";
            }

            if (! empty($config['802_1x_ssid'])) {
                // on configure le wifi en peap mschapv2
                $script_802_1x_wifi .= "        if [ \"\$ssid\" == \"" . $config['802.1x_ssid'] . "\" ]; then
            echo \"configuration wifi : \$interface pour le 802.1x peap mschapv2\"
            nmcli c modify \$interface 802-1x.eap peap 802-1x.identity host/" . strtoupper($info['machine']['samaccountname']) . " \
802-1x.phase2-auth mschapv2 802-1x.password " . $machine_key . " \
802-1x.phase1-peaplabel 1 802-1x.auth-timeout 10 802-1x.system-ca-certs true || true
        fi
";
            }

            $script_wired = "    if nmcli -t -f connection.type c show \$interface | grep -q \"ethernet\" ; then
        echo \"configuration filaire : \$interface\"
        nmcli c modify \$interface 802-3-ethernet.wake-on-lan magic || true
" . $script_802_1x_wired . "
    fi
";

            $script_wifi = "    if nmcli -t -f connection.type c show \$interface | grep -q \"802-11-wireless\" ; then
        echo \"configuration wifi : \$interface\"
        ssid=\$(nmcli -t -f 802-11-wireless.ssid c show \$interface | cut -d\":\" -f2)
" . $script_wifi_wpa . "
" . $script_802_1x_wifi . "
    fi
";
            $script .= "OLDIFS=\$IFS
IFS=\"
\"
for interface in \$(nmcli -t -f UUID c show) ; do
" . $script_wired . "
" . $script_wifi . "
done
IFS=\$OLDIFS
";
        }
    }
    return $script;
}

function system_proxy($config)
{
    $script = '
profile_file="/etc/profile"
wgetrc_file="/etc/wgetrc"
';
    switch ($config['proxy_type']) {
        case "aucun":
            $script .= "
sed -i '/no_proxy=/d' \$profile_file
sed -i '/http_proxy=/d' \$profile_file
sed -i '/https_proxy=/d' \$profile_file
sed -i '/ftp_proxy=/d' \$profile_file
sed -i '/^export http_proxy/d' \$profile_file
sed -i '/^no_proxy/d' \$wgetrc_file
sed -i '/^http_proxy/d' \$wgetrc_file
sed -i '/^https_proxy/d' \$wgetrc_file
sed -i '/^use_proxy = on/d' \$wgetrc_file
. \$profile_file
# On désactive le cache utilisé par l'installeur dans la conf apt
if [ -f '/etc/apt/apt.conf' ]; then
    rm -f /etc/apt/apt.conf || true
fi
if [ -f '/etc/apt/apt.conf.d/99proxy' ]; then
    rm -f /etc/apt/apt.conf.d/99proxy || true
fi
if [ -f '/etc/apt/apt.conf.d/99proxy.conf' ]; then
    rm -f /etc/apt/apt.conf.d/99proxy.conf || true
fi
";
            break;
        case "automatique":
            $config['proxy_address'] = $config['proxy_address'] ?? "10.0.0.1";
            $config['proxy_port'] = $config['proxy_port'] ?? "3128";
        case "manuel":
            $no_proxy = $config['no_proxy'] ?? '.' . $config['domain'] . ',' . $config['se4fs_name'];
            $script .= '
echo "no_proxy=\"' . $no_proxy . '\"" > \$profile_file
echo "http_proxy=\"http://' . $config['proxy_address'] . ':' . $config['proxy_port'] . '\"" >> \$profile_file
echo "https_proxy=\"http://' . $config['proxy_address'] . ':' . $config['proxy_port'] . '\"" >> \$profile_file
echo "ftp_proxy=\"http://' . $config['proxy_address'] . ':' . $config['proxy_port'] . '\"" >> \$profile_file
echo "export http_proxy https_proxy ftp_proxy no_proxy" >> \$profile_file
echo "no_proxy = \"' . $no_proxy . '\"" > \$wgetrc_file
echo "http_proxy = http://' . $config['proxy_address'] . ':' . $config['proxy_port'] . '" >> \$wgetrc_file
echo "https_proxy = http://' . $config['proxy_address'] . ':' . $config['proxy_port'] . '" >> \$wgetrc_file
echo "use_proxy = on" >> \$wgetrc_file
. \$profile_file
';
            if (isset($config['apt_proxy'])) {
                $apt_http_proxy = $config['apt_proxy'];
            } else {
                $apt_http_proxy = 'http://' . $config['proxy_address'] . ':' . $config['proxy_port'];
            }
            $script .= '
echo "Acquire::http::proxy \"' . $apt_http_proxy . '\";
Acquire::https::proxy \"' . $apt_http_proxy . '\";
" > /etc/apt/apt.conf.d/99proxy
';
    }
    return $script;
}

function gnome_proxy($config)
{
    $script = "";
    switch ($config['proxy_type']) {
        case "automatique":
            if (! empty($config['proxy_url'])) {
                $script .= "echo \"configuration proxy : \"
gsettings set org.gnome.system.proxy mode 'auto'
gsettings set org.gnome.system.proxy autoconfig-url '" . $config['proxy_url'] . "'
";
            }
            break;
        case "manuel":
            $script .= "echo \"configuration proxy : \"
gsettings set org.gnome.system.proxy mode 'manual'
gsettings set org.gnome.system.proxy.http host '" . $config['proxy_address'] . "'
gsettings set org.gnome.system.proxy.http port " . $config['proxy_port'] . "
gsettings set org.gnome.system.proxy.https host '" . $config['proxy_address'] . "'
gsettings set org.gnome.system.proxy.https port " . $config['proxy_port'] . "
gsettings set org.gnome.system.proxy.ftp host ''
gsettings set org.gnome.system.proxy.ftp port 0
gsettings set org.gnome.system.proxy.socks host ''
gsettings set org.gnome.system.proxy.socks port 0
gsettings set org.gnome.system.proxy ignore-hosts '[\"localhost\", \"127.0.0.0/8\", \"." . $config['domain'] . "\", \"::1\"]
";
            break;
        case "aucun":
            $script .= "echo \"configuration pas de proxy : \"
gsettings set org.gnome.system.proxy mode 'none'
";
    }
    return $script;
}
?>